Package com.io7m.cedarbridge.schema.ast

# Record Class CBASTPackage

java.lang.Object
java.lang.Record
com.io7m.cedarbridge.schema.ast.CBASTPackage

Record Components:
  `imports` - The package imports
  `language` - The package language
  `name` - The package name
  `protocols` - The package protocols
  `types` - The package types
  `userData` - The user data
  `documentation` - The documentation

public record CBASTPackage(CBASTMutableUserData userData, CBASTPackageName name, CBASTLanguage language, List<CBASTImport> imports, List<CBASTTypeDeclarationType> types, List<CBASTProtocolDeclaration> protocols, List<CBASTDocumentation> documentation) extends Record
A package.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBASTPackage(CBASTMutableUserData userData, CBASTPackageName name, CBASTLanguage language, List<CBASTImport> imports, List<CBASTTypeDeclarationType> types, List<CBASTProtocolDeclaration> protocols, List<CBASTDocumentation> documentation)`
  A package.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<CBASTDocumentation>`
  `documentation()`
  Returns the value of the `documentation` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `List<CBASTImport>`
  `imports()`
  Returns the value of the `imports` record component.
  `CBASTLanguage`
  `language()`
  Returns the value of the `language` record component.
  `CBASTPackageName`
  `name()`
  Returns the value of the `name` record component.
  `List<CBASTProtocolDeclaration>`
  `protocols()`
  Returns the value of the `protocols` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `List<CBASTTypeDeclarationType>`
  `types()`
  Returns the value of the `types` record component.
  `CBASTMutableUserData`
  `userData()`
  Returns the value of the `userData` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CBASTPackage

    public CBASTPackage(CBASTMutableUserData userData, CBASTPackageName name, CBASTLanguage language, List<CBASTImport> imports, List<CBASTTypeDeclarationType> types, List<CBASTProtocolDeclaration> protocols, List<CBASTDocumentation> documentation)
    A package.
    Parameters:
      `imports` - The package imports
      `language` - The package language
      `name` - The package name
      `protocols` - The package protocols
      `types` - The package types
      `userData` - The user data
      `documentation` - The documentation

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### userData

    public CBASTMutableUserData userData()
    Returns the value of the `userData` record component.
    Returns:
      the value of the `userData` record component

  - ### name

    public CBASTPackageName name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### language

    public CBASTLanguage language()
    Returns the value of the `language` record component.
    Returns:
      the value of the `language` record component

  - ### imports

    public List<CBASTImport> imports()
    Returns the value of the `imports` record component.
    Returns:
      the value of the `imports` record component

  - ### types

    public List<CBASTTypeDeclarationType> types()
    Returns the value of the `types` record component.
    Returns:
      the value of the `types` record component

  - ### protocols

    public List<CBASTProtocolDeclaration> protocols()
    Returns the value of the `protocols` record component.
    Returns:
      the value of the `protocols` record component

  - ### documentation

    public List<CBASTDocumentation> documentation()
    Returns the value of the `documentation` record component.
    Returns:
      the value of the `documentation` record component